import os

from langchain.text_splitter import CharacterTextSplitter
from langchain_community.document_loaders import TextLoader
from langchain_community.vectorstores import Chroma

# 加载文档，摘自 https://github.com/limchiahooi/nlp-chinese/blob/master/%E8%A5%BF%E6%B8%B8%E8%AE%B0.txt#L8-L12
raw_documents = TextLoader('/Users/xiexianbin/workspace/code/github.com/xiexianbin/note/static/code/ai/usage/langchain/xiyouji.log', encoding='utf-8').load()

# 分割文档
# chunk_size=400 表示每次读取或写入数据时，数据的大小为 400 个字节, 约200~400个汉字
# chunk_overlap=10 表示两个 chunk 重复的数据大小为 10，防止丢失上小文
text_splitter = CharacterTextSplitter(chunk_size=100, chunk_overlap=10)
documents = text_splitter.split_documents(raw_documents)
print("documents nums:", documents.__len__())

# 生成向量（embedding）
# from langchain_community.embeddings import ModelScopeEmbeddings
# os.environ["CUDA_VISIBLE_DEVICES"]=""
# embeddings = ModelScopeEmbeddings(model_id="damo/nlp_corom_sentence-embedding_english-base", model_revision="v1.0.0")
# vectordb = Chroma.from_documents(documents, embedding=embeddings)
# https://help.aliyun.com/zh/model-studio/developer-reference/use-bailian-in-langchain
# from langchain_openai import OpenAIEmbeddings
# os.environ["OPENAI_API_BASE"] = 'https://dashscope.aliyuncs.com/compatible-mode/v1'
# os.environ["OPENAI_API_KEY"] = 'sk-xxxxxx'
# embedding = OpenAIEmbeddings(model="text-embedding-v3")
from langchain_community.embeddings import DashScopeEmbeddings
# os.environ["DASHSCOPE_API_KEY"]=''
embedding = DashScopeEmbeddings(model="text-embedding-v3")
vectordb = Chroma.from_documents(documents, embedding)
# vectordb = Chroma(persist_directory=<persist_directory>, embedding_function=embedding)
# vectordb.persist()

# 检索
query = "猴子怎么来的？"
docs = vectordb.similarity_search(query, k=3)

# 打印结果
for doc in docs:
    print("---")
    print("metadata: ", doc.metadata)
    print("page_content: ", doc.page_content)
